package ru.dbotthepony.kstarbound.defs.world

import ru.dbotthepony.kstarbound.json.builder.IStringSerializable

enum class SpawnRegion(override val jsonName: String, val enclosed: Boolean, val exposed: Boolean) : IStringSerializable {
	ALL("all", true, true) {
		override fun isCompatible(other: SpawnRegion): Boolean {
			return true
		}
	},

	ENCLOSED("enclosed", true, false) {
		override fun isCompatible(other: SpawnRegion): Boolean {
			return other.enclosed
		}
	},

	EXPOSED("exposed", false, true){
		override fun isCompatible(other: SpawnRegion): Boolean {
			return other.exposed
		}
	};

	abstract fun isCompatible(other: SpawnRegion): Boolean
}
